###factor analysis


##load package
library(readxl)


##load data
df1 <- read_excel("saliencesupp.xlsx")
names(df1)
nrow(df1)


##selecting variables for factor analysis
variables <- c("Frequency Count", 		##number of articles in newspapers
	"stat_ig", 				##mentions in newspapers
	"stat_ep", 				##mentions in newspapers
	"stat_co", 				##mentions in newspapers
	"stat_ec", 				##mentions in newspapers
	"Abstentions", 			##EP abstentions
	"no_recitals_com",			##recitals in proposal
	"no_recitals_final", 		##recitals final document
	"density", 				##number groups mobilized
	"rel_sal1", 			##from survey with IGs
	"rel_sal2", 			##from survey with IGs
	"publicsallog")		##from EES


###if salience assessment missing, set to zero
df1$rel_sal1[is.na(df1$rel_sal1)] <- 0
df1$rel_sal2[is.na(df1$rel_sal2)] <- 0


####determining the number of factors
ev <- eigen(cor(na.omit(df1[,variables]))) 
plot(ev$values, type="b")


#####ML factor analysis
fit_fac1 <- factanal(na.omit(df1[,variables]), 4, rotation="varimax", 
	scores="regression")     
fit_fac2 <- factanal(na.omit(df1[,variables]), 1, rotation="varimax", 
	scores="regression")     


#Chi-square difference test
1-pchisq(as.numeric(fit_fac2$STATISTIC-fit_fac1$STATISTIC), df=(fit_fac2$dof-fit_fac1$dof))


###show results for 4 factor solution
print(fit_fac1, cutoff=.3, digits=2) 

